int main() {
// character constants

    ' ';
    'a';
    '"';
    '_';

    '\a';				// simple escape
    '\b';
    '\e';				// GCC
    '\f';
    '\n';
    '\r';
    '\t';
    '\v';
    '\'';
    '\"'; //"
    '\?';
    '\\';

    '\0';				// octal escape
    '\377';

    '\xf';				// hex escape
    '\xff';

// warnings/errors

    '';					// empty character
    'aa';				// multi-character
    'a\na';				// multi-character, embedded escape
    'a\0a';
    '\xfff';				// hex escape out of range
    '_\377_';				// multi-character
    '_\xff_';
    '\xffff';				// hex escape out of range
    'a\xff34w';
    '\xf_f';				// multi-character
    '\xff_ff';

// string constants

    " ";
    "a";
    "'";
    '_';

    "\a";				// simple escape
    "\b";
    "\e";				// GCC
    "\f";
    "\n";
    "\r";
    "\t";
    "\v";
    "\'";
    "\"";
    "\?";
    "\\";

    "\0";				// octal escape
    "\377";

    "\xf";				// hex escape
    "\xff";

    "";
    "aa";
    "a\na";
    "a\0a";
    "_\377_";
    "_\xff_";
    "\xf_f";
    "\xff_ff";

// warnings/errors

    "\xfff";				// hex escape out of range
    "a\xff34w";
    "\xffff";
}
